
run.test <- function(x, a = 0.05) {
    n = length(x)
    y = rep( 0, (n-1) )
    for( i in 1:(n-1) ) {
        y[i] = sign( x[i+1] - x[i] )
    }
    z = rep( 0, (n-2) )
    for(i in 1:(n-2) ) {
        if( y[i+1] != y[i] ) {
            z[i] = 1
        } else
        z[i] = 0
    }
    if( a != 0.05 ) {
        a = a
    } else
    a = 0.05
    n1 = sum(y == -1)
    n2 = n - n1
    R = sum(z)
    ER = 1 + ( (2 * n1 * n2) / n )
    VR = (2 * n1 * n2 * ( (2 * n1 * n2) - n) ) / ( n * n * (n-1) )
    T = abs( (R - ER) / sqrt(VR) )
    T_tab = qnorm( 1 - (a/2) )
    if(T <T_tab) {
        Conclusion = "The Sample Is  Random"
    } else
    Conclusion="The Sample Is Not Random"
    Conclusion
}

## run.test(runif(50))
