
permutation.test <- function(x, a = 0.05) {
    n = length(x)
    if(n%%3!=0) {
        warning("The Length Of The Sequence Should Be Multiple Of 3")
        x <- head(x, 3 * (n %/% 3))
    }
    t = n/3
    A = matrix(x, t, 3)
    A1 <- A[,1]
    A2 <- A[,2]
    A3 <- A[,3]
    freq = rep(0,6)
    freq[1] = sum( A1 < A2  &  A2 < A3 )
    freq[2] = sum( A1 < A3  &  A3 < A2 )
    freq[3] = sum( A2 < A1  &  A1 < A3 )
    freq[4] = sum( A2 < A3  &  A3 < A1 )
    freq[5] = sum( A3 < A1  &  A1 < A2 )
    freq[6] = sum( A3 < A2  &  A2 < A1 )
    p = rep( (1/6), 6 )
    T = sum( (freq - n*p) * (freq - n*p) / (n*p) )
    if(a != 0.05) {
        a = a
    } else
    a = 0.05
    T_tab = qchisq( 1-(a/2), 5 )
    if(T > T_tab) {
        con = "The Sample Is Not Random" # con => Conclusion
    } else
    con = "The Sample Is Random"
    con
}
